; Half Duplex Interrupt Driven Software UART (AVR305)

#include <avr/io.h>

#define BAUD 9600
#define SB 1	/* Number of stop bits (1, 2, ...) */
#define TX_PORT PORTB	/* Transmit port */
#define TX_PIN PB6	/* Transmit pin */
#define RX_PORT PINB	/* Receive port */
#define RX_PIN PINB6	/* Receive pin */

#define B ((F_CPU - 23 * BAUD) / (6 * BAUD))

#define bitcnt r23	/* bit counter */
#define temp r22	/* temporary storage register */
#define txbyte r24	/* Data to be transmitted */
#define rxbyte r24	/* Received data */

;; suart_putchar
.global suart_putchar
.func suart_putchar
suart_putchar:
	ldi	bitcnt, 9 + SB
	com	txbyte
	sec
1:	brcc	2f
	cbi	_SFR_IO_ADDR(TX_PORT), TX_PIN
	rjmp	3f
2:	sbi	_SFR_IO_ADDR(TX_PORT), TX_PIN
	nop
3:	rcall	uart_delay
	rcall	uart_delay
	lsr	txbyte
	dec	bitcnt
	brne	1b
	ret
.endfunc

;; suart_getchar
.global suart_getchar
.func suart_getchar
suart_getchar:
	ldi	bitcnt, 9
1:	sbic	_SFR_IO_ADDR(RX_PORT), RX_PIN
	rjmp	1b
	rcall	uart_delay
2:	rcall	uart_delay
	rcall	uart_delay
	clc
	sbic	_SFR_IO_ADDR(RX_PORT), RX_PIN
	sec
	dec	bitcnt
	breq	3f
	ror	rxbyte
	rjmp	2b
3:	ret
.endfunc

;; uart_delay
uart_delay:
	ldi	temp, B
1:	dec	temp
	brne	1b
	ret
